#include <pthread.h>
#include <rtai.h>
#include <rtai_fifos.h>

void *thread1( void* arg )
{
	int count = 0;
	void* result = NULL;

	RT_TASK* task1 = rt_task_init_schmod(nam2num("THRED1"), 3, 1024, 1024, SCHED_FIFO, 1 );
	if( task1 )
	{
		printf("task1 start\n");
		rt_make_hard_real_time();

		char buf[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
		int fid = rtf_open_sized( "/dev/rtf0", O_RDWR, 1024 );
		write( fid, buf, sizeof(buf) );
		rt_task_delete( task1 );
		printf("task1 end\n");
	}
	else
	{
		printf("Failed to create task1\n");
	}
	return( result );
}

void* thread2( void* arg )
{
	int count = 0;
	void* result = NULL;

	RT_TASK* task2 = rt_task_init_schmod(nam2num("THRED2"), 2 , 1024, 1024, SCHED_FIFO, 1 );
	if( task2 )
	{
		printf("Task2 start\n");
		rt_make_hard_real_time();

		char buf2[64];
		int fid = rtf_open_sized( "/dev/rtf0", O_RDWR, 1024 );
		read( fid, buf2, 16 );
		for( int i = 0 ; i < 16 ; ++i )
		{
			printf("%02X ", buf2[i] );
		}
		printf("\n");

		rt_task_delete( task2 );
		printf("task2 end\n");
	}
	else
	{
		printf("Failed to create task2\n");
	}
	return( result );
}

main()
{
	pthread_t th1, th2;

	rt_allow_nonroot_hrt();

	RT_TASK* mainTask = rt_task_init_schmod(nam2num("MAIN"), 10, 1024, 1024, SCHED_FIFO, 1 );
	if( NULL == mainTask )
	{
		printf("Failed to create main task.\n");
		return( 0 );
	}

	pthread_create( &th1, NULL, thread1, NULL );
	sleep(2);
	pthread_create( &th2, NULL, thread2, NULL );

	pthread_join( th1, NULL );
	pthread_join( th2, NULL );

	rt_task_delete( mainTask );
}

